/****************************************************************************/
/*																			*/
/*	WINDFORM.C : Fonctions de gestion des formulaires en fentres.			*/
/*				 par Jacques Delavoix, Janvier-Fvrier 1995.				*/
/*				 modifi par Rmi Vanel le 20/9/95							*/
/*				Mise  jour du 24/03/96 par Jacques Delavoix				*/
/*				Fonctions d' Icnification par Olivier Booklage.			*/
/*	Modifi pour Windform 2.55  partir du 13/07/1996 par Jacques Delavoix	*/
/*	Remarques:																*/
/*																			*/
/* -Si open sur une iconifie=>on ne peut pas directement					*/
/*   uniconifier (app_write necessaire)	(Olivier.)							*/
/*																			*/
/****************************************************************************/


#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#ifdef __SOZOBONX__
	#include <stdio.h>					/* sprintf */
	#include <atari.h>					/* KEYTAB */
	#include <xgemfast.h>
	#define	ED_END	EDEND
	#define	ED_CHAR	EDCHAR
	#define objc_edit(A,B,C,D,E)	objc_edit(A,B,C,*D,E,D)
#endif

#ifndef __SOZOBONX__
	#include <aes.h>
	#include <vdi.h>
	#include <tos.h>
#endif

#include "windform.h"
#include "userdefs.h"
#include "icone.rsh"	/* NEW ICONIFICATION */

/* Dclarations des variables */

int app_id, vdi_handle;
int x_desk, y_desk, w_desk, h_desk; /* Coordonnes du bureau */
int buff[8], mousex, mousey, mousek, key, key_s, nbr_clics; /* evnt_multi() */
int w_char, h_char;
int nb_planes;				/* Nombre de plans de couleurs.	*/
int color_3d1, color_3d2;	/* Couleurs pour la 3D */
int wtop;					/* fenetre actuellement active */

/* Variables Internes : */

int hauteur_min;	/* Pour la rduction (Rmi VANEL).	*/
char *window_alert; /* Pointeur sur Alerte "Plus de Fentres" */

static OBJECT	*adr_icone;		/* NEW ICONIFICATION */

#ifndef ACTIVATOR
#define ACTIVATOR		0x600
#endif

#define USR_INDICATOR	0x800
#define USR_ACTIVATOR	0x1800


/* ******** Fonctions prives rserves  windform_do(): ******** */

int action_button(WINDFORM_VAR *ptr_var, int object);
static int do_keybd(OBJECT *tree, int objc);
static int do_button(OBJECT *tree, int objc);
int get_rbutton(OBJECT *tree, int index);
int objc_parent(OBJECT *tree, int index);
void wait_mk(void);		/* attend qu'on relache le bouton */

/* NEW ! Olivier Booklage. */
static void   iconify(WINDFORM_VAR *ptr_var,GRECT *w);
static void uniconify(WINDFORM_VAR *ptr_var,GRECT *w);
static void redraw_icon(WINDFORM_VAR *ptr_var, GRECT *zone);

char rsc1[] = "[2][| The ressource file | ";
char rsc2[] = "| cannot be found.][ Abort ]";

/* Chaine "Par Dfaut" Pour "plus de Fentres" :	*/ 
char no_wind[] = "[2][ There is no Windows| availables ! Please close|"
				" an unused document.][ Cancel ]";


int load_rsc(char *rsc_name, int wind_fail)
{
	int obj;
	char str_alert[256];
	if (rsrc_load(rsc_name) == 0)
	{
		sprintf(str_alert, "%s%s%s" , rsc1, rsc_name, rsc2);
		form_alert(1, str_alert);
		return FALSE;
	}
	window_alert = rsrc_get_string(wind_fail);
	obj = 0;
	do			/* Par Olivier Booklage : */
	{
		rsrc_obfix(rs_trindex[0], obj);
	} while (! (rs_trindex[0][obj++].ob_flags & LASTOB));
	adr_icone = rs_trindex[0];
	return TRUE;
}

void init_var(WINDFORM_VAR *ptr_var, int form_index, int inf_x, int inf_y)
{
	int wx, wy, ww, wh, wh2, x_desk, y_desk, w_desk, h_desk;
	int offset = 0, inf_flag = 0;
	OBJECT *adresse_form;

	rsrc_gaddr(R_TREE, form_index, &adresse_form);
	ptr_var->adr_form = adresse_form;

	if (adresse_form->ob_state & OUTLINED)	/* Ce dcalage est invariable !!! */
		ptr_var->offset = offset = 3;

	form_center(adresse_form, &wx, &wy, &ww, &wh);
	wh2 = wh;
	wind_calc(WC_BORDER, FW_ATTRIB, wx, wy, ww, wh, &wx, &wy, &ww, &wh);
	hauteur_min = (wh - wh2) - 2; /* Taille rduite, addition de Rmi VANEL. */
	wind_get(0, WF_WORKXYWH, &x_desk, &y_desk, &w_desk, &h_desk);
	if (inf_x != 0 || inf_y != 0)	/* si valeurs lues dans fichier .INF ... */
	{
/*	Retombe du developpement de "DECOCALC" : un recadrage automatique dans le
	cas ou les donnes lues dans un fichier "INF" tendraient  faire sortir le
	formulaire de l'cran.	*/
		if (inf_x > (w_desk - ww))
			inf_x = w_desk - (ww + 3);	/* cadrage  droite.	*/
		if (inf_x < 0)
			inf_x = 0;					/* Scurit  Gauche. */
		if (inf_y > (y_desk + h_desk) - wh)
			inf_y = (y_desk + h_desk) - (wh + 3); /* cadrage en bas. */
		if (inf_y < y_desk)
			inf_y = y_desk;				/* cadrage en haut.		*/

		wx = inf_x; wy = inf_y;
		inf_flag = TRUE;
	}
	ptr_var->w_x = wx; ptr_var->w_y = wy;
	ptr_var->w_w = ww; ptr_var->w_h = wh;
	if (inf_flag)		/* ... alors recaler le formulaire sur la fentre. */
	{
		wind_calc(WC_WORK, FW_ATTRIB, wx, wy, ww, wh, &wx, &wy, &ww, &wh);
		adresse_form->ob_x = wx + offset;
		adresse_form->ob_y = wy + offset;
	}
	set_user(adresse_form);	/* Etablissement des boutons USERDEFS.	*/

	/* NEW ICONIFICATION */
/*	ptr_var->iconified=FALSE; */

}


void open_dialog(WINDFORM_VAR *ptr_var, char *w_title, int edit_first, int back)
{
	OBJECT *ptr_objc;
/*	GRECT	w; */

	if (ptr_var->w_handle > 0)
	{

/*		if ( ptr_var->iconified )	 Impossible par cette mthode,il */
/*		{							 Faudrait s'envoyer un message ?	*/
/*			w.g_x=ptr_var->w_x;	*/
/*			w.g_y=ptr_var->w_y; */
/*			w.g_w=ptr_var->w_w; */
/*			w.g_h=ptr_var->w_h; */
/*			uniconify(ptr_var,&w); */
		} */

		wind_set(ptr_var->w_handle, WF_TOP);
	}
	else
	{
		if ((ptr_var->w_handle = wind_create(FW_ATTRIB, ptr_var->w_x,
						ptr_var->w_y, ptr_var->w_w, ptr_var->w_h)) > 0)
		{
			wind_set(ptr_var->w_handle, WF_NAME, w_title);
/*			graf_growbox(0, 0, 0, 0, ptr_var->w_x, ptr_var->w_y,
						ptr_var->w_w, ptr_var->w_h);		GADGET ! */
			wind_open(ptr_var->w_handle, ptr_var->w_x, ptr_var->w_y,
					ptr_var->w_w, ptr_var->w_h);
			ptr_var->edit_objc = edit_first;
			ptr_objc = &(ptr_var->adr_form[edit_first]);
			if ((ptr_objc->ob_flags & EDITABLE) != 0)
				ptr_var->edit_pos = (int)strlen(ptr_objc->ob_spec.tedinfo->te_ptext);
			ptr_var->reduced = FALSE;	/* Rmi VANEL	*/
			ptr_var->iconified = FALSE;	/* O.Booklage	*/
			if (back != 0)
				wind_set(ptr_var->w_handle, WF_BEVENT, 1, 0, 0, 0);
		}
		else
		{
			if (window_alert == 0) /* Alors prendre Alerte par dfaut	*/
				window_alert = no_wind;
			form_alert(1, window_alert);
			ptr_var->w_handle = 0;
		}
	}
}

void redraw_editable(WINDFORM_VAR *ptr_var, int index)
{
	OBJECT *ptr_objc;
	int cursor_pos;

	ptr_objc = &(ptr_var->adr_form[index]);	
	if ( ptr_objc->ob_flags & EDITABLE )	/* Scurit */
	{
		cursor_pos = (int)strlen(ptr_objc->ob_spec.tedinfo->te_ptext);
		ptr_var->edit_pos = cursor_pos;
	}
		/* Provoque un message de redraw :	*/
		form_dial(FMD_FINISH, 0,0,0,0, ptr_var->w_x, ptr_var->w_y, ptr_var->w_w, ptr_var->w_h);
}

void close_dialog(WINDFORM_VAR *ptr_var)
{
	if (ptr_var->w_handle > 0)
	{
		wind_close(ptr_var->w_handle);
		wind_delete(ptr_var->w_handle);
/*		graf_shrinkbox(0, 0, 0, 0, ptr_var->w_x, ptr_var->w_y,
						ptr_var->w_w, ptr_var->w_h);		GADGET ! */
		ptr_var->w_handle = FALSE;
	}
}

void change(WINDFORM_VAR *ptr_var, int object, int state, int redraw)
{
	int etat;
	etat = ptr_var->adr_form[object].ob_state;

	if (state < 0)
	{
		if (state < -1)
			etat ^= 1; /* Inversion de l'tat.	*/
		else
			etat = 0;
	}
	else if (state < 2)
	{
		etat &= ~SELECTED;
		etat |= state;
	}
	else
		etat = state;

	ptr_var->adr_form[object].ob_state = etat;
	if (redraw != 0)
		draw(ptr_var, object);
}

void draw(WINDFORM_VAR *ptr_var, int object)
{
	GRECT r;
	int handle;

	handle = ptr_var->w_handle;
	wind_update(BEG_UPDATE); /* Bloquer le Gestionnaire d'cran */
	if (!ptr_var->iconified)
	{
		wind_get(handle, WF_FIRSTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
		while (r.g_w && r.g_h)
		{
			objc_draw(ptr_var->adr_form, object, MAX_DEPTH, r.g_x, r.g_y,
															r.g_w, r.g_h);
			wind_get(handle, WF_NEXTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
		}
	}
	wind_update(END_UPDATE); /* Libration du Gestionnaire d'cran */
}

int action_button(WINDFORM_VAR *ptr_var, int object)
{
	int flag, old;
	int mkx, mky, mk, test_objc;

	flag = ptr_var->adr_form[object].ob_flags;
	if (flag & SELECTABLE)
	{
		if (flag & RBUTTON)
		{
			if ((old = get_rbutton(ptr_var->adr_form, object)) != 0
				&& old != object)
			{
				change(ptr_var, old, NORMAL, 1);
			}
			change(ptr_var, object, SELECTED , 1);
			wait_mk();
		}
		else
		{	/* action de souris sur button */
			old = 1;
			change(ptr_var, object, -2, 1); /* inverse l'tat */
			do
			{
				graf_mkstate(&mkx, &mky, &mk, &test_objc);
				test_objc = objc_find(ptr_var->adr_form, 0, 8, mkx, mky);
				if (old == 0 && test_objc == object )
				{
					change(ptr_var, object, -2, 1);
					old = 1;
				}
				else if (old == 1 && test_objc != object) 
				{
					change(ptr_var, object, -2, 1);
					old = 0;
				}
			} while (mk == 1);
			if (flag & TOUCHEXIT)
				return object;
			if ((ptr_var->adr_form[object].ob_state & SELECTED) == 0)
				object = 0;
		}
		if (flag & EXIT)
			return object;
	}
	if (flag & TOUCHEXIT)
		return object;
	return FALSE;
}

static int new_objc, new_pos;

int windform_do(WINDFORM_VAR *ptr_var, int event)
{
	GRECT r, rd;
	int wx, wy, ww, wh, cur_pos;
	int dialog = TRUE, cur_objc, object, init_field = FALSE;
	int test_objc, flag;

	new_objc = cur_objc = ptr_var->edit_objc;
	new_pos = cur_pos = ptr_var->edit_pos;
	if (event & MU_MESAG)
	{
		switch(buff[0])
		{
			case WM_REDRAW :
				rd.g_x = buff[4]; rd.g_y = buff[5];
				rd.g_w = buff[6]; rd.g_h = buff[7];

				if (cur_objc)	/* si champ ditable et ....*/
				{
					wind_get(0, WF_TOP, &wx, &wy, &ww, &wh);
					/* NEW ICONIFICATION */
					if (buff[3] == wx && !ptr_var->reduced && !ptr_var->iconified)
					{ /*...si fentre au 1 plan => redessin total. */
						wind_get(buff[3], WF_WORKXYWH, &rd.g_x, &rd.g_y,
								&rd.g_w, &rd.g_h);
						init_field = ED_END;
					}
				}
				wind_update(BEG_UPDATE);
				wind_get(buff[3], WF_FIRSTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
				while (r.g_w && r.g_h)
				{
					if (rc_intersect(&rd, &r))
					{
						if (ptr_var->iconified == TRUE)
						{
							redraw_icon(ptr_var, &r);
						}
						else	/* NEW ICONIFICATION */
						{
							objc_draw(ptr_var->adr_form, 0, 8, r.g_x, r.g_y, r.g_w, r.g_h);
						}
					}
					wind_get(buff[3], WF_NEXTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
				}
				wind_update(END_UPDATE);
				if (cur_objc && init_field)
					objc_edit(ptr_var->adr_form, cur_objc, 0, &cur_pos, init_field);
				break;
			case WM_TOPPED :
				wind_set(buff[3], WF_TOP);
				if (cur_objc && flag_multitache != 1) /* si MULTITOS ... */
				{
					wind_get(buff[3], WF_WORKXYWH, &wx, &wy, &ww, &wh);
					form_dial(FMD_FINISH, 0,0,0,0, wx, wy, ww, wh);				
				}
				break;
			case WM_CLOSED : 
				return CLOSE_DIAL;

			case WM_MOVED :
				wind_set(buff[3], WF_CURRXYWH, buff[4], buff[5], buff[6], buff[7]);
				wind_get(buff[3], WF_WORKXYWH, &wx, &wy, &ww, &wh);
				if (!ptr_var->iconified)
				{
					ptr_var->w_x = buff[4]; ptr_var->w_y = buff[5];
					ptr_var->adr_form->ob_x = wx + ptr_var->offset;
					ptr_var->adr_form->ob_y = wy + ptr_var->offset;
				}
				else	/* NEW ICONIFICATION */
				{
					adr_icone->ob_x = wx;
					adr_icone->ob_y = wy;
				}
				break;
			case WM_FULLED :	/* Nouvelle Fonction par Rmi VANEL !!!	*/
				if (!ptr_var->reduced)
				{	/* on rduit au maximum la fentre en hauteur */
					wind_set(buff[3], WF_CURRXYWH, ptr_var->w_x, ptr_var->w_y,
							ptr_var->w_w, hauteur_min);
					ptr_var->reduced = TRUE;
				}
				else
				{	/* on la rouvre */
					wind_set(buff[3], WF_CURRXYWH, ptr_var->w_x, ptr_var->w_y,
							ptr_var->w_w, ptr_var->w_h);
					ptr_var->reduced = FALSE;
				}
				break;
			case WM_ICONIFY :
				iconify(ptr_var,(GRECT*)(buff+4));
				break;				
			case WM_UNICONIFY :
				uniconify(ptr_var,(GRECT*)(buff+4));
				break;
		}
	}
	else if (event & MU_KEYBD && !ptr_var->reduced && !ptr_var->iconified)
	{
		dialog = do_keybd(ptr_var->adr_form, cur_objc);
		if (key)
		{
			objc_edit(ptr_var->adr_form, cur_objc, key, &cur_pos, ED_CHAR);
			new_objc = cur_objc;
			new_pos = cur_pos;
		}
	}

	else if (event & MU_BUTTON && mousek == 1)
	{
		object = objc_find(ptr_var->adr_form, 0, 8, mousex, mousey);
		if (object > -1 ) 
		{
			flag = ptr_var->adr_form[object].ob_flags;
			if (ptr_var->adr_form[object].ob_state & DISABLED)
				return FALSE;

			else if ((flag & EDITABLE) && ptr_var->w_handle == wtop)
			{
				if ((flag & EXIT) && nbr_clics == 2 && cur_objc == object)
				{
					return object; /* Exit de l'ditable autoris */
				}
				dialog = do_button(ptr_var->adr_form, object);
			}
			else if (flag & (SELECTABLE|RBUTTON|TOUCHEXIT))
			{
				if ((test_objc = action_button(ptr_var, object)) != 0)
					return test_objc;
			}
			else
			{	
				wind_set(buff[3], WF_TOP);
				if (cur_objc && flag_multitache != 1)  /* si MULTITOS ... */
				{
					wind_get(buff[3], WF_WORKXYWH, &wx, &wy, &ww, &wh);
					form_dial(FMD_FINISH, 0,0,0,0, wx, wy, ww, wh);				
				}
				return FALSE;
			}

		}
	}
	if (dialog)
	{
		if (new_objc > 0 && new_objc != cur_objc || new_pos != cur_pos)
		{
			objc_edit(ptr_var->adr_form, cur_objc, 0, &cur_pos, ED_END);
			cur_pos = new_pos;
			objc_edit(ptr_var->adr_form, new_objc, 0, &cur_pos, ED_END);
			cur_objc = new_objc;
		}
		ptr_var->edit_objc = cur_objc;
		ptr_var->edit_pos = cur_pos;
		return FALSE;		/* LE DIALOGUE CONTINUE !!!!!!!!!!!!!!!!!! */
	}
	else
		return new_objc;
}

void wait_mk(void)
{
	int k, dummy;
	do
		graf_mkstate(&dummy, &dummy, &k, &dummy);
	while(k == 1 || k == 3);
}

/* get_rbut : Renvoie l'index d'un bouton slectionn dans
*				un groupe de Radio_buttons.
* Paramtres:	tree = adresse de l'arbre d'objets.
*				index = renvoy par objc_find() et qui
*				doit faire partie du groupe de R_Buttons.
*/


int get_rbutton(OBJECT *tree, int index)
{
	int parent;
	register OBJECT *objet;

	parent = objc_parent(tree, index);
	index = tree[parent].ob_head; /* 1 objet du groupe de R_Buttons */
	while (index != parent && index >= 0)
	{
		objet = &tree[index];
		if (objet->ob_state & SELECTED)
			return index;
		index = objet->ob_next; /* Objet suivant */
	}
	return FALSE;	/* Pas Trouv */
}

/* Recherche du Parent (Racine du groupe de R_buttons). */


int objc_parent(OBJECT *tree, int index)
{
	int temp;
	if (!index)
		return FALSE;	/* Evite une recherche inutile */
	else 
	{
		do
		{
			temp = tree[index].ob_next;
			if (tree[temp].ob_tail == index) /* dans ce cas, 'index'
										est gal au dernier 'enfant'. */	
				return temp;									
			index = temp;
		} while (1);
	}
}


static int do_keybd(OBJECT *tree, int objc)
{
	int dialog, len, pos, index, key_short;
	char *ed_text;
	OBJECT *ptr_objc;
	dialog = form_keybd(tree, objc, objc, key, &new_objc, &key);
	if (dialog)
	{
		if (key == 0)
		{
			if (new_objc)	/* si NOUVEAU champ ditable.	*/
			{
				ptr_objc = &tree[new_objc];
				new_pos = (int) strlen((ptr_objc->ob_spec.tedinfo)->te_ptext);
			}
		}
		else
		{
			if (objc)		/* Si champ ditable.	*/
			{
				ptr_objc = &tree[objc];
				ed_text = (ptr_objc->ob_spec.tedinfo)->te_ptext;
				len = (int) strlen(ed_text);
				pos = new_pos;
				switch (key) {
					case 0x4b34 :	/* Shift <- : Curseur en dbut de Champ */
						pos = 0;
						key = 0;
						break;
					case 0x4d36 :	/* Shift -> : Curseur en fin de Champ */
						pos = len;
						key = 0;
						break;
					case 0x7300 :	/* Control <- : Saute un mot	*/
						while (pos)
						{
							pos--;
							if (ed_text[pos] == ' ')
								break;
						}
						key = 0;

						break;
					case 0x7400 :	/* Control -> : Saute un mot	*/
						while (pos < len)
						{
							pos++;
							if (ed_text[pos] == ' ')
								break;
						}
						if (pos < len)
							pos++;
						key = 0;
						break;
				}
				new_pos = pos;
			}
			if (key != 0 && key_s == K_ALT)		/* Raccourcis claviers	*/
			{
				key_short = stdkey(key);
				index = 1;
				do
				{
					ptr_objc = &tree[index]; /* pointe sur l'objet  traiter */
					ed_text = 0;
					if ((ptr_objc->ob_state & DISABLED) == 0 &&
						(ptr_objc->ob_type & 0x200) != 0)
					{
/*	Si l'ob_type tendu & 2 est diffrent de '0' alors raccourci clavier.
	(compatibilit avec BIG et INTERFACE).	*/
						switch (ptr_objc->ob_type & 0xff)
						{
							case G_BUTTON :
								ed_text = ptr_objc->ob_spec.free_string;
								break;
							case G_USERDEF :
								ed_text = (char *)((ptr_objc->ob_spec.userblk)->ub_parm);
						}
						if (ed_text && (ed_text = strchr(ed_text, '[')) != 0)
						{
							if (key_short == toupper(ed_text[1]))
							{
								key = 0;
								/* Simuler un clic sur l'objet et retour : */
								return form_button(tree, index, 1, &new_objc);
							}
						}
					}
					index ++; /* Prpare l'objet suivant ... */
				/* ... sauf si l'objet actuel est le dernier : */
				} while((ptr_objc->ob_flags & LASTOB) == 0);
			}
		}
	}
	return dialog;
}

static int do_button(OBJECT *tree, int objc)
{
	int i, pos, dialog, offset;
	int objc_x, objc_y, depht_text[8];
	char test[80];
	OBJECT *ptr_objc;
	char *objc_text, *objc_temp;

	dialog = form_button(tree, objc, 1, &new_objc);
	if (new_objc > 0 && dialog)
	{
		ptr_objc = &tree[objc];
		objc_text = (ptr_objc->ob_spec.tedinfo)->te_ptext;
		objc_temp = (ptr_objc->ob_spec.tedinfo)->te_ptmplt;
		objc_offset(tree, objc, &objc_x, &objc_y);
		vqt_extent(vdi_handle, objc_temp, depht_text);

		offset = (ptr_objc->ob_width) - depht_text[2];
		objc_x = mousex - objc_x;
		switch ((ptr_objc->ob_spec.tedinfo)->te_just)
		{
			case 1:
				objc_x -= offset;
			case 2:
				objc_x -= offset / 2;
		}
		pos = 0;
		for (i = 1; i <= strlen(objc_temp); i++)
		{
			strncpy(test, objc_temp, i);
			test[i + 1] = '\0';
			vqt_extent(vdi_handle, test, depht_text);
			if (depht_text[2] > objc_x)
				break;
			if (objc_temp[i] == '_')
				pos++;
		}
		new_pos = min((int) strlen(objc_text), pos);
	}
	return dialog;
}

#ifndef __SOZOBONX__

int rc_intersect(GRECT *p1, GRECT *p2)
{
	int tx, ty, tw, th;
	tw = min(p2->g_x + p2->g_w, p1->g_x + p1->g_w);
	th = min(p2->g_y + p2->g_h, p1->g_y + p1->g_h);
	tx = max(p2->g_x, p1->g_x);
	ty = max(p2->g_y, p1->g_y);
	p2->g_x = tx;
	p2->g_y = ty;
	p2->g_w = tw - tx;
	p2->g_h = th - ty;
	return ((tw > tx) && (th > ty));
}

#endif

/*  stdkey() Version personnalise. */

int stdkey(int key_code)
{
	KEYTAB *kt;
	kt = Keytbl((void *)-1, (void *)-1, (void *)-1);
	return toupper(kt->shift[(char)(key_code >> 8)]);
}

/************************************************************/
/*															*/
/*	Routines USERDEFS										*/
/*															*/
/************************************************************/

int cdecl under_button(PARMBLK *parmblock)
{
	int flags, x, y, w, h, flags_no_bistable;
	int test = 0, under_pos, tx, ty; 
	int back_color, lb_color, lh_color, txt_color = BLACK, small_button;
	int char_height, cell_height, dummy;
	int xy_clip[4], xy_bar[8], attributs[10];
	char chaine[60];
	char *string; /* Pointeur texte pour BUTTON */
	char *key_short;

	xy_clip[0] = parmblock->pb_xc;
	xy_clip[1] = parmblock->pb_yc;
	xy_clip[2] = parmblock->pb_wc + xy_clip[0] - 1;
	xy_clip[3] = parmblock->pb_hc + xy_clip[1] - 1;
	vs_clip(vdi_handle, TRUE, xy_clip);

	flags = parmblock->pb_tree[parmblock->pb_obj].ob_flags;
	flags_no_bistable = flags & NO_BISTABLE;
	small_button = parmblock->pb_tree[parmblock->pb_obj].ob_type & SMALL_FLAG;
	string = (char *) parmblock->pb_parm;

	x = parmblock->pb_x;
	y = parmblock->pb_y;
	w = parmblock->pb_w;
	h = parmblock->pb_h;

	vqt_attributes(vdi_handle, attributs);
	if (small_button == FALSE)
		char_height = attributs[7];
	else
		char_height = 4;	/* Petite fonte systme. */
	vst_height(vdi_handle, char_height, &dummy, &char_height, &dummy, &cell_height);

	/* CALCUL DU TEXTE */
	if ((key_short = strchr(string, '[')) != 0)
	{
		strpcopy(chaine, string, key_short);
		vqt_extent(vdi_handle, chaine, xy_bar);
		under_pos = xy_bar[2];	/* Position du soulign */
		key_short++;
		strcat(chaine, key_short);
	}
	else
		strcpy(chaine, string);

	vqt_extent(vdi_handle, chaine, xy_bar);
	tx = x + (w - xy_bar[2])/2;
	ty = y + (char_height + (h - cell_height)/2);

	if (small_button == FALSE)
	{
		x -= 3; y -= 3; w += 5; h += 5;
	}
	else
	{
		tx++; ty++;
	}

	if ((flags & USR_ACTIVATOR) != 0)	/* Pour la 3 D ! */
	{
		if (small_button == FALSE)
		{
			x -= 2; y -= 2; w += 4; h += 4;
		}
		else
		{
			x -= 1; y -= 1; w += 2; h += 2;
		}
	}
	xy_bar[0] = x; xy_bar[1] = y;
	xy_bar[2] = x + w; xy_bar[3] = y + h;
	
	vswr_mode(vdi_handle, MD_REPLACE);
	if ((parmblock->pb_currstate & OUTLINED) != 0)
	{
		vsf_color(vdi_handle, WHITE);	/* Pour OUTLINED ...*/
		vsf_interior(vdi_handle, 1);
		v_bar(vdi_handle, xy_bar);		/* ..dessin du fond de l'objet */
	}
	else
	{
		if (flags & DEFAULT)
			test++;			/* Un cadre pour "DEFAULT"	*/
		if (flags & EXIT)
			test++;			/* Un cadre pour "EXIT"		*/
	}
	vsf_interior(vdi_handle ,0);
	vswr_mode(vdi_handle, MD_TRANS);
	vsf_color(vdi_handle, BLACK);		/* Couleur des cadres	*/

	if ((parmblock->pb_currstate & OUTLINED) != 0 || test == 2)
	{
		v_bar(vdi_handle, xy_bar);		/* Cadre Exterieur */
		test--;
	}
	xy_bar[0] ++; xy_bar[1] ++; xy_bar[2] --; xy_bar[3] --;

	if (test > 0)
		v_bar(vdi_handle, xy_bar);		/* Cadre Intermdiaire */
	xy_bar[0] ++; xy_bar[1] ++; xy_bar[2] --; xy_bar[3] --;


	if ((parmblock->pb_currstate & OUTLINED) == 0) /* Cadre Intrieur */
		v_bar(vdi_handle, xy_bar);
	xy_bar[0] ++; xy_bar[1] ++; xy_bar[2] --; xy_bar[3] --;

	flags &= USR_ACTIVATOR;
	if (flags != 0)
	{
		back_color = color_3d1;
		if ((parmblock->pb_currstate & SELECTED) == 0)
		{
			lh_color = WHITE;
			lb_color = color_3d2;

			if (flags == USR_ACTIVATOR)	/* ACTIVATOR et NORMAL */

			{
				tx--; ty--;
			}
		}
		else
		{
			lh_color = BLACK;
			lb_color = WHITE;
			if (flags == USR_INDICATOR)	/* INDICATOR et SELECTED */
			{
				back_color = color_3d2;
				txt_color = WHITE;
				lb_color = color_3d1;
			}
		}
	}
	else if ((parmblock->pb_currstate & SELECTED) != 0)
	{
			txt_color = WHITE;
			back_color = BLACK;
	}
	else
	{
			back_color = WHITE;
	}
	vsf_interior(vdi_handle, 1);
	vsf_color(vdi_handle, back_color);
	v_bar(vdi_handle, xy_bar);	/* Remplissage Intrieur du bouton */

	if (flags)
	{
		xy_bar[0]++;
		xy_bar[4] = xy_bar[2];
		xy_bar[5] = xy_bar[1] +1;
		xy_bar[1] = xy_bar[3];
		vsl_color(vdi_handle, lb_color);
		v_pline(vdi_handle, 3, xy_bar);	/* Trac ligne basse et droite */
		xy_bar[0]--; xy_bar[5]--;
		xy_bar[2] = xy_bar[0];
		xy_bar[3] = xy_bar[5];
		xy_bar[1]--;xy_bar[4]--;
		vsl_color(vdi_handle, lh_color);
		v_pline(vdi_handle, 3, xy_bar);	/* Trac ligne gauche et haute */
	}
	vst_color(vdi_handle, txt_color);
	v_gtext(vdi_handle, tx, ty, chaine);
	if (key_short != 0 && ((parmblock->pb_currstate & SELECTED) == 0 ||
					flags_no_bistable == 0))
	{
		if (small_button != 0)
		{
			ty++;
		}
		vst_effects(vdi_handle, 8);	/* mode "Soulign"	*/
		v_gtext(vdi_handle, tx + under_pos, ty, " ");
		vst_effects(vdi_handle, 0);	/* mode "Normal"	*/
	}
	vswr_mode(vdi_handle, MD_REPLACE);
	vst_color(vdi_handle, BLACK);
	vst_height(vdi_handle, attributs[7], &dummy, &dummy, &dummy, &dummy);
	return (parmblock->pb_currstate & DISABLED);
}


void set_objc(OBJECT *addr_obj, int cdecl (*code)(PARMBLK *parmblock))
{
	int temp;
	register USERBLK *user;
	if ((user = (USERBLK *) malloc(sizeof(USERBLK))) != 0)
	{
		user->ub_code = code;
		addr_obj->ob_type = (addr_obj->ob_type & 0xff00) | G_USERDEF;
		user->ub_parm = (long) addr_obj->ob_spec.userblk;
		addr_obj->ob_spec.userblk = user;

/* Translation des flags 3D en ob_flags_11 et ob_flags_12 : */
		if ((temp = (addr_obj->ob_flags & ACTIVATOR)) != 0)
		{
			temp <<= 2;
			addr_obj->ob_flags = (addr_obj->ob_flags & ~ACTIVATOR) | temp;
		}
	}
}

/* Fonction de bibliothque : Copie dans "dest" la portion de chaine  partir
	du pointeur "start", jusqu'au caractre plac juste avant le pointeur "stop". 
	"start" et "stop" doivent obligatoirement pointer dans la mme chaine.
	Dans tous les cas "dest" est termine par le caractre de fin de chaine '\0'.*/

char *strpcopy(char *dest, char *start, char *stop)
{
	char *ptr_dest = dest;
	while (start < stop && (*(ptr_dest)++ = *(start++)) != 0);

	*ptr_dest = '\0';
	return dest;
}

char *rsrc_get_string(int index)
{
	char **free_string;
	rsrc_gaddr(R_FRSTR, index, &free_string);
	return *free_string;
}


/* MODIFIED for C Sozobon 2.02 eXtended by Olivier Booklage : */

/*----------------------------------------------------------------------*
 * Gestion de l'Iconification	par	Olivier Booklage.					*
 *----------------------------------------------------------------------*/

static void iconify(WINDFORM_VAR *ptr_var,GRECT *w)
{
	graf_shrinkbox(w->g_x,w->g_y,w->g_w,w->g_h,ptr_var->w_x,ptr_var->w_y,ptr_var->w_w,ptr_var->w_h);
	wind_set(ptr_var->w_handle, WF_ICONIFY,w->g_x,w->g_y,w->g_w,w->g_h);
	ptr_var->iconified = TRUE;
}

static void uniconify(WINDFORM_VAR *ptr_var,GRECT *w)
{
	graf_growbox( ptr_var->w_x,ptr_var->w_y,ptr_var->w_w,ptr_var->w_h,w->g_x,w->g_y,w->g_w,w->g_h);
	wind_set(ptr_var->w_handle, WF_UNICONIFY,w->g_x,w->g_y,w->g_w,w->g_h);
	ptr_var->iconified = FALSE;
}

static void redraw_icon(WINDFORM_VAR *ptr_var, GRECT *zone)
{
	int xw, yw, ww, hw;

	wind_get (ptr_var->w_handle, WF_WORKXYWH, &xw, &yw, &ww, &hw);
	adr_icone[0].ob_x = xw;
	adr_icone[0].ob_y = yw;
	adr_icone[0].ob_width = ww;
	adr_icone[0].ob_height = hw;
	adr_icone[1].ob_x = (ww - adr_icone[1].ob_width) / 2;
	adr_icone[1].ob_y = (hw - adr_icone[1].ob_height) / 2;
	objc_draw (adr_icone, ICONE, 1, zone->g_x, zone->g_y, zone->g_w,zone->g_h);
}
